C   28/06/88 209031817  MEMBER NAME  NAUFLX   (FORT)        FORTRAN
C
      SUBROUTINE NAUFLX(IPAR,E0,FLUXN)
C
C ++ FUUNCTION TO GIVE NEUTRINO FLUX BASED ON NAUMOV FLUX
C                  T.KAJITA  SEP.3,1992
C
C -- VOLKOVA FLUX IS INSTALLED FOR E(NEU)>10GEV
C -- SOLAR MIN,MAX OR ANY COMBINATION OF MIN/MAX IS NOT AVAILABLE
C            IF(SOLACT=1.) -- SOLAR MAX.
C            IF(SOLACT=0.) -- SOLAR MIN.
C         (  IF(SOLACT=0.5) -- AVERAGE OF SOLAR MIN/MAX )
C
C    IPAR : NEUTRINO TYPE
C        =1001  NUE
C        =-1001 NUEBAR
C        =1002  NUMU
C        =-1002 NUMUBAR
C    E    : ENERGY OF NEUTRINO (UNIT : GEV)
C    FLUXN: FLUX OF NEUTRINO FOR IPAR AND E.
C
      COMMON /NAUMF / ENEU(33),
     &       FEMIN(33), FEMAX(33), FEBMIN(33), FEBMAX(33),
     &       FMMIN(33), FMMAX(33), FMBMIN(33), FMBMAX(33)
      COMMON /SOLACT/ ISOL, SOLACT
C
C
      IF ( E0.GT.10. ) GO TO 1000
C
      E=E0
      IF ( E.GT.ENEU(33) ) E=ENEU(33)
      FLUXN=0.
      IF(IABS(IPAR).NE.1001 .AND. IABS(IPAR).NE.1002)RETURN
      IF(ISOL.EQ.0) SOLACT=0.5
      IF(SOLACT.LT.0.) SOLACT=0.
      IF(SOLACT.GT.1.) SOLACT=1.
      IF(E.LE.0.01) RETURN
      IF(E.GE.100.) RETURN
      IF ( E.LE.ENEU(1) ) E=ENEU(1)+0.0001
C
C
C
      I=1
  100 IF(ENEU(I).GT.E)GO TO 200
      I=I+1
      IF(I.GE.34) THEN
                  I=33
                  GO TO 200
                  END IF
      GO TO 100
C
C--FIT FLUX BY F=A*E**B
  200 CONTINUE
C+NEU(E)
      IF(IPAR.EQ. 1001) THEN
         BMIN=ALOG(FEMIN(I-1)/FEMIN(I))/ALOG(ENEU(I-1)/ENEU(I))
         BMAX=ALOG(FEMAX(I-1)/FEMAX(I))/ALOG(ENEU(I-1)/ENEU(I))
         AMIN=FEMIN(I-1)/ENEU(I-1)**BMIN
         AMAX=FEMAX(I-1)/ENEU(I-1)**BMAX
                        END IF
C+NEU(E)-BAR
      IF(IPAR.EQ.-1001) THEN
         BMIN=ALOG(FEBMIN(I-1)/FEBMIN(I))/ALOG(ENEU(I-1)/ENEU(I))
         BMAX=ALOG(FEBMAX(I-1)/FEBMAX(I))/ALOG(ENEU(I-1)/ENEU(I))
         AMIN=FEBMIN(I-1)/ENEU(I-1)**BMIN
         AMAX=FEBMAX(I-1)/ENEU(I-1)**BMAX
                        END IF
C+NEU(MU)
      IF(IPAR.EQ. 1002) THEN
         BMIN=ALOG(FMMIN(I-1)/FMMIN(I))/ALOG(ENEU(I-1)/ENEU(I))
         BMAX=ALOG(FMMAX(I-1)/FMMAX(I))/ALOG(ENEU(I-1)/ENEU(I))
         AMIN=FMMIN(I-1)/ENEU(I-1)**BMIN
         AMAX=FMMAX(I-1)/ENEU(I-1)**BMAX
                        END IF
C+NEU(MU)-BAR
      IF(IPAR.EQ.-1002) THEN
         BMIN=ALOG(FMBMIN(I-1)/FMBMIN(I))/ALOG(ENEU(I-1)/ENEU(I))
         BMAX=ALOG(FMBMAX(I-1)/FMBMAX(I))/ALOG(ENEU(I-1)/ENEU(I))
         AMIN=FMBMIN(I-1)/ENEU(I-1)**BMIN
         AMAX=FMBMAX(I-1)/ENEU(I-1)**BMAX
                        END IF
C
      FLUXN=SOLACT*(AMAX*E**BMAX)+(1.-SOLACT)*(AMIN*E**BMIN)
      IF ( E0.GT.ENEU(33) ) GO TO 1000
      RETURN
C
 1000 CONTINUE
      FLUXN3=FLUXN
      FLUXN=  FLUX(IPAR,E0)
      IF(E0.GT.10.) RETURN
      FLUXG3 =  FLUX(IPAR,ENEU(33) )
      FLUXN = FLUXN *(1.- (10.-E0)/(10.-ENEU(33))*(1.-FLUXN3/FLUXG3) )
C
      RETURN
      END
