C   02/07/91 312152221  MEMBER NAME  RFLUX    (FORT)        FORTRAN
C
      SUBROUTINE RFLUX(IMODE,ENEU,DIR,IPAR,WEIGHT)
C
C  CALCULATE RELATIVE FLUX VALUE BETWEEN GAISSER AND (HONDA OR LEE)
C                      T.KAJITA  JULY 1, 1991
C
C  NAUMOV FLUX IS SUPPRTED T.KAJITA  SEP 03,1992
C
C  INPUTS  IMODE;  =1--HONDA/GAISSER   =2--LEE/GAISSER
C                  =3--NAUMOV/GAISSER
C
C          ENEU ; ENERGY OF NEUTRINO (GEV)
C          DIR  ; DIRECTION OF NEUTRINO (NO MEANING FOR NAUMOV/GAISSER)
C          IPAR ; IP OF NEUTRINO
C
C  OUTPUT  WEIGHT; (HONDA OR LEE)/GAISSER FOR A GIVEN DIR AND IPAR
C
      DIMENSION DIR(3)
C
      WIEGHT=1.
C
C (HONDA/GAISSER)
      IF(IMODE.EQ.1) THEN
      CALL GAIFLX(ENEU,DIR,IPAR,GFLUX)
      CALL HONFLX(ENEU,DIR,IPAR,HFLUX)
      WEIGHT = HFLUX/GFLUX
      END IF
C
C (LEE/GAISSER)
      IF(IMODE.EQ.2) THEN
      CALL GAIFLX(ENEU,DIR,IPAR,GFLUX)
      CALL LEEFLX(ENEU,DIR,IPAR,HFLUX)
      WEIGHT = HFLUX/GFLUX
      END IF
C
C (NAUMOV/GAISSER) T.K   SEP 03, 1992
      IF(IMODE.EQ.3) THEN
      GFLUX=FLUX(IPAR,ENEU)
      CALL NAUFLX(IPAR,ENEU,FLUXN)
      WEIGHT = FLUXN/GFLUX
      END IF
C
      RETURN
      END
